<?php
namespace Ecommerce\Services;

use Zeedhi\Framework\DTO;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;

class AtualizarFreteService {

    protected $entityManager;
    protected $environment;

    public function __construct(EntityManager $entityManager, $environment) {
        $this->entityManager = $entityManager;
        $this->environment   = $environment;
    }
    
    public function updateValorFrete($row) {
        $sqlUpdate = "UPDATE PEDCOLETA 
                        SET VRFRETEFORNEPEDCOL = :P_VRFRETEFORNEPEDCOL 
                        WHERE CDFILIAL = :P_CDFILIAL 
                              AND NRPEDIDOCOL = :P_NRPEDIDOCOL 
                              AND CDFORNECED = :P_CDFORNECED";

        try {
            $std = $this->entityManager->getConnection()->prepare($sqlUpdate);
            $std->execute($row);
            
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    public function checarFornecedor($row) {
        $sqlCheck = "SELECT IDTPFRETFORN 
                        FROM FORNECEDOR 
                            WHERE IDTPFRETFORN = 'F' 
                            AND CDFORNECED = :P_CDFORNECED";
        
        try {
            $std = $this->entityManager->getConnection()->prepare($sqlCheck);
            $std->execute($row);
            $result = $std->fetchAll();
            return $result;
        } catch (Exception $e) {
            throw $e;
        }                    
    } 
}
