<?php
namespace Ecommerce\Services;

use Doctrine\ORM\EntityManager;

class ItemPedColSave
{

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
    }

    public function insertItemPedCol($cdfilial, $nrpedcoleta, $cdproduto, $cdmarca)
    {

        $sql = "INSERT INTO ITEMPEDCOL(CDFILIAL, NRPEDCOLETA, CDFORNECED, CDREGIAO, CDPRODUTO, CDMARCA, VRITEMPEDCOL, VRANTITPEDCOL)
                SELECT
                   PEDCOLETA.CDFILIAL,
                   PEDCOLETA.NRPEDCOLETA,
                   PEDCOLETA.CDFORNECED,
                   PEDCOLETA.CDREGIAO,
                   PRMARCPEDCOL.CDPRODUTO,
                   PRMARCPEDCOL.CDMARCA,
                   PRMARCPEDCOL.VRPRECUNIPRMARC,
                   PRMARCPEDCOL.VRULTPRECPRMARC
                FROM PRMARCPEDCOL, PEDCOLETA
                WHERE PRMARCPEDCOL.CDFILIAL     = :P_CDFILIAL
                  AND PRMARCPEDCOL.NRPEDIDOCOL  = :P_NRPEDIDOCOL
                  AND PRMARCPEDCOL.CDPRODUTO    = :P_CDPRODUTO
                  AND PRMARCPEDCOL.CDMARCA      = :P_CDMARCA
                  AND PEDCOLETA.CDFILIAL        = PRMARCPEDCOL.CDFILIAL
                  AND PEDCOLETA.NRPEDIDOCOL     = PRMARCPEDCOL.NRPEDIDOCOL";

        $stmt = $this->entityManager->getConnection()->prepare($sql);

        $stmt->execute(
            array(
                "P_CDFILIAL" => $cdfilial,
                "P_NRPEDIDOCOL" => $nrpedcoleta,
                "P_CDPRODUTO" => $cdproduto,
                "P_CDMARCA" => $cdmarca
            )
        );

    }

}